import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.Query;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }


  public Professor createProfessor(String name, long salary, 
          String street, String city, String state, String zip) {
      Professor emp = new Professor();
      emp.setName(name);
      emp.setSalary(salary);
      
      Address addr = new Address();
      addr.setStreet(street);
      addr.setCity(city);
      addr.setState(state);
      addr.setZip(zip);
      emp.setAddress(addr);

      em.persist(emp);
      em.persist(addr);
      
      return emp;
  }

  public void removeProfessor(int id) {
    Professor emp = findProfessor(id);
    if (emp != null) {
      em.remove(emp);
    }
  }

  public Professor raiseProfessorSalary(int id, long raise) {
    Professor emp = em.find(Professor.class, id);
    if (emp != null) {
      emp.setSalary(emp.getSalary() + raise);
    }
    return emp;
  }

  public Professor findProfessor(int id) {
    return em.find(Professor.class, id);
  }

  public Collection<Professor> findAllProfessors() {
    Query query = em.createQuery("SELECT e FROM Professor e");
    return (Collection<Professor>) query.getResultList();
  }
}
